#include <windows.h>
#include <stdio.h>
#include <commctrl.h>

//FStringBSCԱ
//صַ
//http://go6.163.com/edyfox/ef/7th/pages/tiptrick/file4.zip
#include "/BSC/FString.h"

//FArrayBSCԱ
//صַ
//http://go6.163.com/edyfox/ef/8th/pages/tiptrick/file4.zip
#include "/BSC/FArray.h"

#include "resource.h"

HINSTANCE hInst;
FArray<FString>myArray; //ļб

HWND hwnd;       //ش

//ؼ
HWND progress,   //
     lb_remain,  //ʣʱ
     lb_curdir,  //ǰĿ¼
     lb_curfile; //ǰļ

FString GetFileName(char *filename)
{
    char *pointer;

    FString temp=reverse(filename);

    if(pointer=strstr(temp, "\\"))
        *pointer=NULL;

    return reverse(temp);
}

FString GetDirName(char *filename)
{
    FString DirName=GetFileName(reverse(strstr(reverse(filename), "\\")+1));
    if(DirName[1]==':')
        DirName+="\\";

    return DirName;
}

//ݹôļб
void FindFiles(FString pathname)
{
    pathname+="\\";
    FString FullName=pathname+"*.*";

    WIN32_FIND_DATA myData;
    HANDLE myHandle=FindFirstFile(FullName, &myData);
    BOOL NotFinished=(myHandle!=NULL);

    while(NotFinished)
    {
        if(strcmp(myData.cFileName,".")!=0&&strcmp(myData.cFileName,"..")!=0)
        {
            //ļ
            if((myData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)==FILE_ATTRIBUTE_DIRECTORY)
                //ݹòĿ¼
                FindFiles(pathname+myData.cFileName);
            else
                //һļ
                myArray.Add(pathname+myData.cFileName);
        }

        //һļ
        NotFinished=FindNextFile(myHandle,&myData);
    }
}

//Ի WM_INITDIALOG Ϣ
void OnInit(HWND hDlg)
{
    InitCommonControls();
    SetWindowPos(hDlg, HWND_TOPMOST, 30, 51, 0, 0, SWP_NOSIZE);
    Animate_Open(GetDlgItem(hDlg, IDC_AVI), MAKEINTRESOURCE(IDR_AVI));

    //ȡؼ
    progress  =GetDlgItem(hDlg, IDC_PROGRESS);
    lb_remain =GetDlgItem(hDlg, IDC_REMAIN  );
    lb_curdir =GetDlgItem(hDlg, IDC_CURDIR  );
    lb_curfile=GetDlgItem(hDlg, IDC_CURFILE );

    FString myString=GetCommandLine();
    
    //ļǷ
    if(myString[0]=='\"')
        FindFiles(mid(myString, 1, 2));
    else
        FindFiles(left(myString, 2));

    //ý
    SendMessage(progress, PBM_SETRANGE, 1, MAKELPARAM(0, myArray.GetCount()));
    SendMessage(progress, PBM_SETSTEP, 1, 0);

    SetTimer(hDlg, 0, 1, NULL);
}

//Ի WM_TIMER Ϣ
void OnTimer(HWND hDlg)
{
    static unsigned int cur(0);  //ѡɾļĿ
    unsigned int total=myArray.GetCount(); //ļ

    FString Scale="";       //ʱ䵥λ
    static int pre(0);        //ǰһʣʱ
    static FString preDir;    //ǰһιĿ¼

    int remain=(total-cur)/25;

    //ѡʵʱ䵥λ
    if(remain>60)
    {
        remain=(int)((float)remain/60.0+.5);
        Scale="";

        if(remain>60)
        {
            remain=(int)((float)remain/60.0+.5);
            Scale="Сʱ";
        }
    }

    //ʾʣʱ䡱
    if(remain!=pre)
    {
        FString myText;
        myText.buffer();
        wsprintf(myText, "ʣ %i %s", remain, Scale);
        SetWindowText(lb_remain, myText);
        pre=remain;
    }

    //ʾ XXX ɾ
    FString curDir=GetDirName(myArray[cur]);
    if(preDir!=curDir)
    {
        FString myText;
        myText.buffer();
        wsprintf(myText, "ӡ%s", curDir);
        SetWindowText(lb_curdir, myText);
        preDir=curDir;
    }

    //ʾڡɾļ
    SetWindowText(lb_curfile, GetFileName(myArray[cur]));

    //ģӲ̹
    FILE *temp;
    if((temp=fopen(myArray[cur],"rb"))!=NULL)
        fclose(temp);

    //
    SendMessage(progress, PBM_STEPIT, 0, 0);
    cur++;

    if(cur==total)
    {
        KillTimer(hDlg, 0);
        Animate_Close(GetDlgItem(hDlg, IDC_AVI));
        EndDialog(hDlg, IDOK);
    }
}

//Ի
BOOL CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg)
    {
    case WM_INITDIALOG:
        OnInit(hDlg);
        break;
    case WM_TIMER:
        OnTimer(hDlg);
        break;
    default:
        return(FALSE);
    }
    
    return(TRUE);
}

//
LRESULT CALLBACK WndProc(HWND hwnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
    switch(uMessage)
    {
    case WM_CLOSE:
        PostQuitMessage(1);
        break;
    default:
        return DefWindowProc(hwnd, uMessage, wParam, lParam);
    }
    return 0;
}

BOOL InitApp()
{
    WNDCLASSEX wc;
    HICON WindowIcon=LoadIcon(hInst, MAKEINTRESOURCE(IDR_MAINFRAME));

    wc.style         = CS_HREDRAW|CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInst;
    wc.hIcon         = WindowIcon;
    wc.hCursor       = LoadCursor(hInst, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = "Scare";

    if (!RegisterClassEx(&wc))
    {
        if (!RegisterClass((LPWNDCLASS)&wc.style))
            return FALSE;
    }

    DestroyIcon(WindowIcon);
    return TRUE;
}

BOOL Create()
{
    hwnd = CreateWindow("Scare",
                        "ɾ...",
                        WS_OVERLAPPEDWINDOW,
                        100, 100,
                        200, 100,
                        NULL,
                        NULL,
                        hInst,
                        NULL);

    if (!hwnd)
        return FALSE;

    ShowWindow(hwnd, SW_HIDE);
    DialogBox(hInst, MAKEINTRESOURCE(IDD_SCARE_DIALOG), hwnd, DlgProc);
    PostQuitMessage(0);
    return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR, int)
{
    //ڡرճб
    HINSTANCE hKernelLib;
    typedef void (CALLBACK pRegFunction)(unsigned long,int);
    pRegFunction *RegisterServiceProcess;

    hKernelLib=LoadLibrary("kernel32.dll");
    if(hKernelLib)
    {
        RegisterServiceProcess=(pRegFunction *)GetProcAddress(hKernelLib,"RegisterServiceProcess");
        if(RegisterServiceProcess)
            RegisterServiceProcess(GetCurrentProcessId(), 1);
    }

    MSG msg;
    hInst=hInstance;

    if (!hPrevInstance)
        if (!InitApp())
            return 1;

    if (!Create())
        return 1;

    while (GetMessage(&msg,NULL, 0, 0))
        if (!TranslateAcceleratorA(msg.hwnd, NULL, &msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }

    return 0;
}
